!define APP "CDex 1.60 beta 1-cs1"

Name "${APP}"
Caption "${APP}"

OutFile "cdex_setup.exe"
InstallDir "$PROGRAMFILES\CDex"
ShowInstDetails show
ShowUninstDetails show

XPStyle on

;icon CDex.ico
;UninstallIcon Uninstall.ico
;EnabledBitmap cdex1.bmp
;DisabledBitmap cdex2.bmp

UninstallText "Deinstall CDex, click on the NEXT button to continue "
InstallDirRegKey HKEY_LOCAL_MACHINE "Software\CDex" "Instpath"


LicenseText "Please read this before continuing:" "Next"
LicenseData "CDex.txt"
SubCaption 0 " "

SetOverwrite on

ComponentText "Select the components to be installed"
DirText "Please, select destination directory:"

AutoCloseWindow true
SetDatablockOptimize on
SetCompress force

; The stuff to install
Section "!CDex"

  SectionIn RO

  DetailPrint " - Installation of the files base"

  IfFileExists $INSTDIR\CDex.exe exexist
  goto noexe
  exexist:
  MessageBox MB_YESNO|MB_ICONEXCLAMATION|MB_TOPMOST \
    "An old installation of CDex was detected. This poses normally no problem, \
    $\r$\rDo you want to overwrite the old installation?"\
  IDYES noexe

  MessageBox MB_OKCANCEL|MB_ICONSTOP|MB_TOPMOST "Continue installation ?" IDCANCEL noexe
  Abort

  noexe:
  SetOutPath $INSTDIR
  DetailPrint " - Installation of the base files"
  File "CDex\CDex.exe"
  File "CDex\CDex.exe.manifest"  
  File "CDex\CDRip.dll"
  File "CDex\libsndfile.dll"
  File "CDex\CDex.cnt"
  File "CDex\CDex.hlp"
  File "CDex\Changes.txt"
  File "CDex\Readme.txt"

  DetailPrint " - Adding uninstall information to the registry file"

  WriteRegStr HKEY_LOCAL_MACHINE "Software\CDex" "Instpath" "$INSTDIR"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\CDex" "DisplayName" "CDex extraction audio"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\CDex" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "$INSTDIR\uninstall.exe"
  
  DetailPrint " - Configuration"
  
  IfFileExists $INSTDIR\CDex.ini iniexist
  goto noini
  iniexist:
  MessageBox MB_YESNO|MB_ICONEXCLAMATION|MB_TOPMOST \
    "An existing configuration file was found.$\r$\rDo you want to delete the old configuration file?" \
    IDNO noauto
  delete $INSTDIR\CDex.ini

  noini:
  StrCmp $MUSIC "" nomusic
    StrCpy $0 "$MUSIC"
    Goto donemusic
  nomusic:
    ReadRegStr $0 HKEY_CURRENT_USER "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" "Personal"
    StrCpy $0 "$0\My Music"
    CreateDirectory "$0"
  donemusic:
  
  WriteINIStr "$INSTDIR\CDex.ini" "General" "MP3OutputDir" "$0"
  WriteINIStr "$INSTDIR\CDex.ini" "General" "CnvOutputDir" "$0"
  WriteINIStr "$INSTDIR\CDex.ini" "General" "WAVInputDir" "$0"
  WriteINIStr "$INSTDIR\CDex.ini" "General" "MP3InputDir" "$0"
  WriteINIStr "$INSTDIR\CDex.ini" "General" "PlayDir" "$0"
  WriteINIStr "$INSTDIR\CDex.ini" "General" "CDDBPath" "$COMMONFILES\CDDB"
  WriteINIStr "$INSTDIR\CDex.ini" "General" "CDDBEmailAddress" "user@cdexos.sourceforge.net"
  WriteINIStr "$INSTDIR\CDex.ini" "General" "CDDBAutoConnect" "1"
noauto:
SectionEnd


SubSection Codecs

Section "LAME mp3 DLL 3.97 alpha 10"
  SetOutPath $INSTDIR
  SetOverwrite ifnewer
  File "CDex\lame_enc.dll"
  SetOutPath $INSTDIR\Plugins
  File "CDex\Plugins\in_mp3.dll"
SectionEnd

Section "Ogg Vorbis 1.1.0 DLLs"
  SetOutPath $INSTDIR
  SetOverwrite ifnewer
  File "CDex\vorbis.dll"
  File "CDex\ogg.dll"
  File "CDex\vorbisenc.dll"
  SetOutPath $INSTDIR\Plugins
  File "CDex\Plugins\in_vorbis.dll"
  File "CDex\Plugins\in_vorbis.txt"
SectionEnd

Section "FLAC DLLs"
  SetOutPath $INSTDIR
  SetOverwrite ifnewer
  File "CDex\libFLAC.dll"
  SetOutPath $INSTDIR\Plugins
  File "CDex\Plugins\in_flac.dll"
SectionEnd

Section "Monkey's Audio 3.99 DLLs"
  SetOutPath $INSTDIR
  SetOverwrite ifnewer
  File "CDex\MACDll.dll"
  SetOutPath $INSTDIR\Plugins
  File "CDex\Plugins\in_APE.dll"
SectionEnd

Section "Windows Media Audio 9"
  SetOutPath $INSTDIR
  SetOverwrite ifnewer
  File "CDex\WMA8Connect.dll"
SectionEnd

Section "MP2 Encoding"
  SetOutPath $INSTDIR
  SetOverwrite ifnewer
  File "CDex\MP2Enc.dll"
  SetOutPath $INSTDIR\Plugins
  File "CDex\Plugins\in_mp3.dll"
SectionEnd

SubSectionEnd


Section "Language Packs"
  SetOutPath $INSTDIR\lang
  File "CDex\lang\*.cdex.lang"
SectionEnd


Section "Start Menu Shortcuts"
  DetailPrint " - Creating Start Menu shortcuts"
  CreateDirectory $SMPROGRAMS\CDex
  SetOutPath $INSTDIR
  CreateShortCut "$SMPROGRAMS\CDex\CDex.lnk" "$INSTDIR\CDex.exe"
  CreateShortCut "$SMPROGRAMS\CDex\CDexPlayer.lnk" "$INSTDIR\CDex.exe" /PLAY
  CreateShortCut "$SMPROGRAMS\CDex\CDex Help.lnk" "$INSTDIR\CDex.hlp"
  CreateShortCut "$SMPROGRAMS\CDex\CDex Home Page.lnk" "http://cdexos.sourceforge.net"
  CreateShortCut "$SMPROGRAMS\CDex\Uninstall CDex.lnk" "$INSTDIR\uninstall.exe"
SectionEnd


Section "Desktop Shortcut"
  DetailPrint " - Creating desktop shortcut"
  SetOutPath $INSTDIR
  CreateShortCut "$DESKTOP\CDex.lnk" "$INSTDIR\CDex.exe"
SectionEnd


Section /o "Install Script and Source Diffs"
  SetOutPath $INSTDIR
  File "CDex.nsi"
  File "CDex\Diffs-cs1.txt"
SectionEnd



Function .onInstSuccess
   MessageBox MB_YESNO|MB_ICONQUESTION|MB_TOPMOST "Congratulations ! CDex installation has been completed.$\r$\rView the readme file?" IDNO nohelp
   ExecShell open "$INSTDIR\Readme.txt"
goto fxend
   nohelp:
	fxend:
FunctionEnd


Section "Uninstall"

DetailPrint " - Deleting main files..."
  Delete /rebootok "$INSTDIR\CDex.exe"
  Delete           "$INSTDIR\CDex.exe.manifest"
  Delete /rebootok "$INSTDIR\CDRip.dll"
  Delete /rebootok "$INSTDIR\libsndfile.dll"
  Delete           "$INSTDIR\CDex.cnt"
  Delete           "$INSTDIR\CDex.hlp"
  Delete           "$INSTDIR\Changes.txt"
  Delete           "$INSTDIR\Readme.txt"
  Delete           "$INSTDIR\Diffs-cs1.txt"
  Delete           "$INSTDIR\*.prf.ini"
  Delete           "$INSTDIR\CDex.ini"
  Delete           "$INSTDIR\CDex.nsi"

  Delete /rebootok "$INSTDIR\lame_enc.dll"
  Delete /rebootok "$INSTDIR\vorbis.dll"
  Delete /rebootok "$INSTDIR\ogg.dll"
  Delete /rebootok "$INSTDIR\vorbisenc.dll"
  Delete /rebootok "$INSTDIR\MACDll.dll"
  Delete /rebootok "$INSTDIR\libFLAC.dll"
  Delete /rebootok "$INSTDIR\WMA8Connect.DLL"
  Delete /rebootok "$INSTDIR\MP2Enc.dll"
  Delete           "$INSTDIR\lang\*.cdex.lang"
  Delete /rebootok "$INSTDIR\Plugins\in_mp3.dll"
  Delete /rebootok "$INSTDIR\Plugins\in_vorbis.dll"
  Delete           "$INSTDIR\Plugins\in_vorbis.ini"
  Delete           "$INSTDIR\Plugins\in_vorbis.txt"
  Delete /rebootok "$INSTDIR\Plugins\in_APE.dll"
  Delete /rebootok "$INSTDIR\Plugins\in_flac.dll"

  Delete           "$INSTDIR\uninstall.exe"

  RmDir "$INSTDIR\lang"
  RmDir "$INSTDIR\Plugins"
  RmDir "$INSTDIR"

DetailPrint " - Delete shortcuts..."
  Delete "$WINDIR\CDex.ini"
  Delete "$DESKTOP\CDex.lnk"
  RmDir /r "$SMPROGRAMS\CDex"
  
DetailPrint " - Delete registry entries..."
  DeleteRegValue HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\CDex" "DisplayName"
  DeleteRegValue HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\CDex" "UninstallString"

DetailPrint " - Uninstall done."

SectionEnd
